#include <qprocess.h>
#include <qsettings.h>
#include <qstring.h>
#include <qstringlist.h>

#if ( _WINDOWS || ESVN_WIN )
#include <windows.h>
#else
#include <unistd.h>
#endif
#include <stdio.h>

//using namespace std;

int main (int argc, char *argv[])
{
	//printf("args: %d\n", argc);
	//if (argc < 5 )
	//	return 3;

	QSettings	settings;

	settings.setPath("umputun.com", "esvn");

	settings.beginGroup("/esvn");
	QString esvn_diff_mask = settings.readEntry("/progs/diff", "kdiff3" );
	settings.endGroup();


	if (esvn_diff_mask.isEmpty()) {
		printf("empty diff mask\n");
		return 2;
	}

	QStringList elems = QStringList::split(' ', esvn_diff_mask);

	QProcess* proc = new QProcess(NULL);
	proc->addArgument(elems[0]);

	//find position of '-L'
	int pos = 0;
	for (int p=1; p<argc; p++) {
		QString arg = argv[p];
		//printf("%d=%s \n", p,argv[p]);
		if (arg == "-L" && pos == 0) {
			pos = p;
//			printf("!%d\n", pos);
		}
	}

	if (elems.size() == 1) {
		proc->addArgument(argv[pos+4]);
		proc->addArgument(argv[pos+5]);
	}
	else {
		for (size_t i=1; i<elems.size() ; i++) {
			QString e = elems[i];
			//printf("e:%s\n", e.ascii());
			if (e == "f1" || e == "F1") proc->addArgument(argv[pos+4]); else
			if (e == "f2" || e == "F2") proc->addArgument(argv[pos+5]); else
			if (e == "a1" || e == "A1") proc->addArgument(QString(argv[pos+1]).replace('\t', ' ')); else
			if (e == "a2" || e == "A2") proc->addArgument(QString(argv[pos+3]).replace('\t', ' ')); else
				proc->addArgument(e);
		}

	}

//	printf("start \n");
//	for (size_t j=0; j<proc->arguments().size(); j++) 
//		printf("a:%s \n", (proc->arguments())[j].ascii());
	
	if (!proc->start())
		return 1;

	while (proc->isRunning())
#if ( _WINDOWS || ESVN_WIN )
		Sleep(1000);
#else
		usleep(1000);
#endif

	return proc->exitStatus();
}
