#include "svn_commands.h"


// Diff command ---------------------------------------------------------------------------------------

int C_SvnCommands::diff(const QString& file_dir_name_1, const QString& file_dir_name_2, 
						const QString& rev, bool use_external_cmd, bool non_recursive, bool notice_ancestry, 
						const QString& extensions,  QStringList& out_txt) 
{
	proc->clearArguments();
	proc->addArgument(svn_); proc->addArgument("diff");
	if (rev != "") {
		proc->addArgument("-r");
		proc->addArgument(rev);
	}

	if (!file_dir_name_1.isEmpty()) {
		proc->addArgument("--old");
		proc->addArgument(file_dir_name_1);
	}

	proc->addArgument("--new");
	if (!file_dir_name_2.isEmpty()) 
		proc->addArgument(file_dir_name_2);
	else 
		proc->addArgument(file_dir_name_1);
	


	if (non_recursive) 
		proc->addArgument("--non-recursive");

	if (notice_ancestry) 
		proc->addArgument("--notice-ancestry");


	if (!extensions.isEmpty()) {
		proc->addArgument("--extentions");
		proc->addArgument(extensions);		
	}


	if (use_external_cmd) {
		proc->addArgument("--diff-cmd");
		proc->addArgument("esvn-diff-wrapper");		
		return execCommand(false);
	}
	else	
		return execCommand(SC_APPEND_USER_PASS, &out_txt);

}

